=== debian/changelog ===
deepin-kwin (4:6.0.3) unstable; urgency=medium

  * fix: access illegal memory in createTimespanDBusMessage
  * fix: com.deepin.wm dbus has changed in v25
  * fix(splitbar): can't show when use qt6
  * fix: hoverleave dde-dock preview,window show error
  * fix: adapt tabbox qml to qt6
  * chore(tabbox): Simplify loading switcher from kf6 KPackage
  * fix: kpackage install namespace in kf6
  * fix: schedule repaint after call takeScreenShot

 -- rewine <luhongxu@deepin.org>  Wed, 16 Apr 2025 18:07:48 +0800

deepin-kwin (4:6.0.2) unstable; urgency=medium

  * fix: dxcb may not loaded in qt6
  * fix(debian): error links in debian

 -- rewine <luhongxu@deepin.org>  Wed, 09 Apr 2025 09:44:27 +0800

deepin-kwin (4:6.0.1) unstable; urgency=medium

  * fix: add kglobalacceld as depends

 -- rewine <luhongxu@deepin.org>  Thu, 03 Apr 2025 10:59:54 +0800

deepin-kwin (4:6.0.0) unstable; urgency=medium

  * Port to qt6 

 -- rewine <luhongxu@deepin.org>  Mon, 24 Mar 2025 14:39:13 +0800

deepin-kwin (4:5.27.2.214-deepin214-1) unstable; urgency=medium

  [zhangyu]
  * fix: 291055\275731\264449\287273\288537

 -- zhangyu <zhangyud@uniontech.com>  Thu, 05 Dec 2024 20:04:18 +0800
