=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export QT_SELECT=6

libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages) kwin-common
include /usr/share/pkg-kde-tools/qt-kde-team/2/library-packages.mk
include /usr/share/dpkg/pkg-info.mk


%:
	dh $@

override_dh_python3:
	dh_python3 usr/share/kconf_update/


override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DDVERSION="6.0.0" \
		-DBUILD_ON_V25=ON \
		-DBUILD_TESTING=OFF \
		-DKWIN_BUILD_KCMS=OFF

override_dh_auto_test:
	# Disable auto tests at build time
	:

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a
